<?php
/////////////////////////////////
// Quand la page est affichée, le JavaScript enclenche l'appel de ce Web Service pour:
// - récupérer le contenu de la liste courante afin de remplir le tableau des données en interrogeant le registre
// - récupérer le contenu des listes déroulantes utilisées dans le tableau des données en interrogeant le registre
// - exécuper des actions de modifications/ajouts/suppressions de données vis à vis du tableau de données
//   avec enregistrement dans le registre
/////////////////////////////////

// initialisation
  $retour=array();
  $retour["succes"]=1;
  $retour["erreur"]="";
  $retour["resultat"]["liste"]=array();
  $retour["resultat"]["liste_deroulante"]=array();
  $retour["resultat"]["liste_tete"]=array();
  $retour["resultat"]["intitules"]=array();

//error_log ("BIB_WS_LISTE-request: ".print_r($_REQUEST,true));

// récupération des variables venant du JavaScript de l'écran de sécurité
  $urlpagebase=$_REQUEST["urlpagebase"];
  $nom_liste=$_REQUEST["nom_liste"];
  $code=$_REQUEST["code"];
  $nom=$_REQUEST["nom"];
  $valeur=$_REQUEST["valeur"];
  $operation=$_REQUEST["operation"];
  $langue=$_REQUEST["langue"];

// on récupère les "_parametres"
  $tmppage1=explode ("/",$urlpagebase);
  $nbspage=count($tmppage1);
  $tmp1=$_SESSION["registre"]["profiles"]["defaut"]["pages"];
  for ($i = 0; $i < $nbspage; $i++) {
    $tmp2=$tmp1 [$tmppage1[$i]];
    $tmp1=$tmp2;
  }

  $registreCOMPLET=new tvs_registre();
  $tmp1=$registreCOMPLET->registre_expurge_retour ($tmp1);

// on récupère les infos de la liste courante
  $tableaulistes=$tmp1["_parametres"]["listes"][$nom_liste];

// on récupère le chemin de la liste courante
  $chemin_liste=$tableaulistes["chemin"];
  $retour["resultat"]["chemin"] = $chemin_liste;

// on récupère l'entete des champs
  $champs_liste=$tableaulistes["nom"];

  $champs_langue=array();
  if ( is_array($champs_liste) ) {
//   unset ($champs_liste["_COMPLET"]);
// passer en revue chaque champs
// et stockage pour le RETOUR
   foreach ($champs_liste as $champs => $champsvaleurs) {
//    unset ($champsvaleurs["_COMPLET"]);
// nom du champs, intitule
    foreach ($champsvaleurs as $champ => $champsvaleur) {
//     unset ($champsvaleur["_COMPLET"]);
     if ($champsvaleur["largeur"] == "") {
      $champsvaleur["largeur"]=0;
      }
     array_push($retour["resultat"]["liste_tete"], array("nom"=>$champ,"valeur"=>"", "largeur"=>$champsvaleur["largeur"] ));
     array_push($champs_langue, array("nom"=>$champ,"langue"=>strval($champsvaleur["langue"])));
    }
   }
  }
// détection du cas où il n'y a pas de champs nommé : codé VALEUR
  $nbslangue=count($champs_langue);
  if ($nbslangue == 1 and $champs_langue[0]["nom"] == "VALEUR") {
   $VALEUR=1;
  } else {
   $VALEUR=0;
  }

// on récupère les intitulés des textes
$chemin_intitulestexte=$tmp1["_parametres"]["intitules_texte"]["chemin"];
$liste_intitulestexte=$tmp1["_parametres"]["intitules_texte"]["liste"];
$arraylistetexte = explode(" ",$liste_intitulestexte);
foreach ($arraylistetexte as $texte){
 $tmp=get_intitule ($chemin_intitulestexte, $texte, array());
 $retour["resultat"]["intitules"][$texte]=$tmp;
}

// on traite les listes déroulantes 
  $MD_liste=$tableaulistes["liste_deroulante"];

// si menu déroulant
  if ( is_array($MD_liste) ) {
// on récupère le contenu des listes déroulantes
   $registreMD=new tvs_registre();

// passer en revue chaque menu déroulant
// et stockage pour le RETOUR
//   unset ($MD_liste["_COMPLET"]);
   $no=-1;
   foreach ($MD_liste as $MD => $MDvaleur) {
    $no++;

// nom du menu déroulant
    array_push($retour["resultat"]["liste_deroulante"], array("nom"=>$MD));

// récupérer la liste des entrées (nom)
    $noeud_MD1=$registreMD->get_node_by_chemin($MDvaleur["chemin"]);
    $ID_MD1=$noeud_MD1["ID"];
    $noeud_MD2=$registreMD->get_enfants($ID_MD1);

// récupérer la liste des entrées (intitulé)
    foreach ($noeud_MD2 as $noeud1) {
     if ($MDvaleur["langue"] == "1") {
      $noeud_MD3=$registreMD->get_node_by_chemin($noeud1["chemin"]."/".$langue);
      array_push($retour["resultat"]["liste_deroulante"][$no], array("nom"=>$noeud1["nom"],"valeur"=>$noeud_MD3["valeur"]));
     } elseif ($MDvaleur["langue"] == "0") {
      $noeud_MD3=$registreMD->get_enfants($noeud1["ID"]);
      array_push($retour["resultat"]["liste_deroulante"][$no], array("nom"=>$noeud1["nom"],"valeur"=>$noeud_MD3[0]["valeur"]));
     } else {
      $noeud_MD3=$registreMD->get_node_by_chemin($noeud1["chemin"]."/".$MDvaleur["langue"]."/".$langue);
      array_push($retour["resultat"]["liste_deroulante"][$no], array("nom"=>$noeud1["nom"],"valeur"=>$noeud_MD3["valeur"]));
     }
    }
   }
  }

// traitement
  $registre=new tvs_registre();

  try {
// récupération du point d'entrée de la liste
    $noeud_liste=$registre->get_node_by_chemin($chemin_liste);
    $ID_liste=$noeud_liste["ID"];
    if ($code != "") {
        $noeud_code=$registre->get_node_by_nom($code, $ID_liste);
        $ID_code=$noeud_code["ID"];
    }

// Actions possibles
// modification - ajout - suppression des données
    if ($operation == "update_code") { ////////////////// MAJ CODE
        $noeud_code["nom"]=$valeur;
        $registre->niv2_update_node($noeud_code);
    } elseif ($operation == "update_valeur") { ////////// MAJ VALEUR

     if ($VALEUR == 1) {
// différentes langues ou non
      if ($champs_langue[0]["langue"] == 1) {
        $noeud_nom=$registre->get_node_by_nom($langue, $ID_code);
        $noeud_nom["valeur"]=$valeur;
        $registre->create_node_chemin(array(), $chemin_liste."/".$code."/".$langue, $valeur, "");
      } else {
        $noeud_code["valeur"]=$valeur;
        $registre->niv2_update_node($noeud_code);
      }
     } else {
        $noeud_nom=$registre->get_node_by_nom($nom, $ID_code);
// cas de valeur selon la langue
        $test=0;
        foreach ($champs_langue as $CL => $CLvaleur) {
         if ($nom == $CLvaleur["nom"] and $CLvaleur["langue"] == "1" ){
          $test=1;
          $registre->create_node_chemin(array(), $chemin_liste."/".$code."/".$nom."/".$langue, $valeur, "");
         }
        }
// cas de valeur hors la langue
        if ($test == "0" ) {
         if ( is_array($noeud_nom) == true ) {
          $noeud_nom["valeur"]=$valeur;
          $registre->niv2_update_node($noeud_nom);
         } else {
error_log("ADMIN_SECURITE_LISTE.PHP: UPD 3 cas a verifier !!!!");
          $registre->create_node_chemin(array(), $chemin_liste."/".$code."/".$nom, $valeur, "");
         }
        }
     }
    } elseif ($operation == "delete_element") { ///////// DELETE ELEMENT
        $tmp=$registre->get_node_by_ID($ID_code);
        $chemin=$tmp["chemin"];
        $test=$registre->metawb_is_node_exportable($tmp["chemin"]);
        $registre->delete_tree($ID_code);
        if ($test == "mwb_export") {
            metawb_log_registre ("supprimer_noeud", $chemin, "", "", "");
        }
    } elseif ($operation == "add_element") { //////////// ADD ELEMENT
        $noms=explode("|",$nom);
        $valeurs=explode("|",$valeur);

        if ($VALEUR == 1) {
// différentes langues ou non
         if ($champs_langue[0]["langue"] == 1) {
          $registre->create_node_chemin(array(), $chemin_liste."/".$code."/".$langue, $valeurs[1], "");
         } else {
          $registre->create_node_chemin(array(), $chemin_liste."/".$code, $valeurs[1], "");
         }
        } else {
         $registre->create_node_chemin(array(), $chemin_liste."/".$code, "", "");
         $nbs=count($noms);
         for ($i = 1; $i < $nbs; $i++) {
// cas de valeur selon la langue
          $test=0;
          foreach ($champs_langue as $CL => $CLvaleur) {
           if ($noms[$i] == $CLvaleur["nom"] and $CLvaleur["langue"] == "1" ){
            $test=1;
            $registre->create_node_chemin(array(), $chemin_liste."/".$code."/".$noms[$i]."/".$langue, $valeurs[$i], "");
           }
          }
// cas de valeur hors la langue
          if ($test == "0" ) {
           $registre->create_node_chemin(array(), $chemin_liste."/".$code."/".$noms[$i], $valeurs[$i], "");
          }
         }
        }
    }
  } catch (tvs_exception $e) {
    $retour["erreur"]=utf8_encode(get_exception($e->get_infos()));
    $retour["succes"]=0;
  }

// récupération de la liste des éléments afin de (re-)remplir le tableau de la page
try {
    $liste1=$registre->get_enfants($ID_liste);
} catch (tvs_exception $e) {
    $retour["erreur"]=utf8_encode(get_exception($e->get_infos()));
    $retour["succes"]=0;
    $output = $json->encode($retour);
    print($output);
}

// récupération des valeurs pour chaque élément
// et stockage pour le RETOUR
  $no=-1;
// passage en revue de chaque enregistrement (code)
  foreach ($liste1 as $ligne) {
    $no++;
    $ID_ligne=$ligne["ID"];
    $code=$ligne["nom"];

    array_push($retour["resultat"]["liste"], array("code"=>$code));

// VALEUR ou plusieurs
    if ($VALEUR == 1) {
// différentes langues ou non
     if ($champs_langue[0]["langue"] == 1) {
      $noeud_nb_enfants=$registre->get_nb_enfants($ID_ligne);
      if ($noeud_nb_enfants > 0) {
       $noeud_enfants=$registre->get_enfants($ID_ligne);
// passage en revue de chaque champs de cet enregistrement
       foreach ($noeud_enfants as $enfant) {
        if ( $langue == $enfant["nom"] ) {
         array_push($retour["resultat"]["liste"][$no], array("nom"=>"VALEUR","valeur"=>$enfant["valeur"]));
        }
       }
      }
     } else {
         array_push($retour["resultat"]["liste"][$no], array("nom"=>"VALEUR","valeur"=>$ligne["valeur"]));
     } // différentes langues ou non
    } else {

     $noeud_nb_enfants=$registre->get_nb_enfants($ID_ligne);
     if ($noeud_nb_enfants > 0) {
      $noeud_enfants=$registre->get_enfants($ID_ligne);

      $no1=-1;
// passage en revue de chaque champs de cet enregistrement
      foreach ($noeud_enfants as $enfant) {
       $no1++;
       $test=0;
       foreach ($champs_langue as $CHN => $CHV) {
        if ( $CHV["nom"] == $enfant["nom"] AND $CHV["langue"] == "1" ) {
         $test=1;
        }
       }
       if ( $test == 0 ) {
        array_push($retour["resultat"]["liste"][$no], array("nom"=>$enfant["nom"],"valeur"=>$enfant["valeur"]));
       } else {
        $enfant_CH=$registre->get_node_by_chemin($enfant["chemin"]."/".$langue);
        array_push($retour["resultat"]["liste"][$no], array("nom"=>$enfant["nom"],"valeur"=>$enfant_CH["valeur"]));
       }
      }
     }
    } // VALEUR ou plusieurs
  }

//error_log ("RETOUR-LISTE: ".print_r($retour,true));
// conversion de l'array RETOUR en JSON et envoi au JavaScript
  $output = $json->encode($retour);
  print($output);
?>
